summaryrefslogtreecommitdiffstats
path: root/network/frr
diff options
context:
space:
mode:
author Thibaut Notteboom <thibaut.notteboom@gmail.com>2018-11-04 23:36:44 +0000
committer Willy Sudiarto Raharjo <willysr@slackbuilds.org>2018-11-10 07:46:54 +0700
commit09200da542a12a7216285cbe63aefa356d869e09 (patch)
tree9c457cd21a243b47e55f2992c35f8e10e85a39a2 /network/frr
parent0775bf8a5bdb04b7c58789070054344a6c6c431d (diff)
downloadslackbuilds-09200da542a12a7216285cbe63aefa356d869e09.tar.gz
slackbuilds-09200da542a12a7216285cbe63aefa356d869e09.tar.xz
network/frr: Added (The FRRouting Protocol Suite).
Signed-off-by: David Spencer <idlemoor@slackbuilds.org>
Diffstat (limited to 'network/frr')
-rw-r--r--network/frr/README24
-rw-r--r--network/frr/doinst.sh34
-rw-r--r--network/frr/frr.SlackBuild160
-rw-r--r--network/frr/frr.info10
-rw-r--r--network/frr/slack-desc19
5 files changed, 247 insertions, 0 deletions
diff --git a/network/frr/README b/network/frr/README
new file mode 100644
index 0000000000..0f8ba5ae72
--- /dev/null
+++ b/network/frr/README
@@ -0,0 +1,24 @@
+FRRouting is free software that manages various IPv4 and IPv6 routing
+protocols.
+
+Currently FRRouting supports BGP4, BGP4+, OSPFv2, OSPFv3, RIPv1,
+RIPv2, RIPng, IS-IS, PIM-SM/MSDP and LDP as well as very early
+support for EIGRP and NHRP.
+
+Groupname and Username
+
+You must have the 'frr' group and user to run this script,
+for example:
+
+ # groupadd -g 357 frr
+ # useradd -d /var/run/frr -s /bin/false -u 357 -g frr frr
+
+You also need a 'frrvty' group :
+
+ # groupadd -g 358 frrvty
+
+And to add 'frr' to 'frrvty' group
+
+ # usermod -a -G frrvty frr
+
+WARNING : this package conflicts with quagga.
diff --git a/network/frr/doinst.sh b/network/frr/doinst.sh
new file mode 100644
index 0000000000..1e362de2ce
--- /dev/null
+++ b/network/frr/doinst.sh
@@ -0,0 +1,34 @@
+config() {
+ NEW="$1"
+ OLD="$(dirname $NEW)/$(basename $NEW .new)"
+ # If there's no config file by that name, mv it over:
+ if [ ! -r $OLD ]; then
+ mv $NEW $OLD
+ elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
+ # toss the redundant copy
+ rm $NEW
+ fi
+ # Otherwise, we leave the .new copy for the admin to consider...
+}
+
+preserve_perms() {
+ NEW="$1"
+ OLD="$(dirname $NEW)/$(basename $NEW .new)"
+ if [ -e $OLD ]; then
+ cp -a $OLD ${NEW}.incoming
+ cat $NEW > ${NEW}.incoming
+ mv ${NEW}.incoming $NEW
+ fi
+ config $NEW
+}
+
+preserve_perms etc/rc.d/rc.frr.new
+config etc/logrotate.d/frr.new
+config etc/frr/daemons.new
+config etc/frr/vtysh.conf.new
+
+if [ -x /usr/bin/install-info ]; then
+ chroot . /usr/bin/install-info --info-dir=/usr/info /usr/info/frr-info.gz 2> /dev/null
+ chroot . /usr/bin/install-info --info-dir=/usr/info /usr/info/frr-info-1.gz 2> /dev/null
+ chroot . /usr/bin/install-info --info-dir=/usr/info /usr/info/frr-info-2.gz 2> /dev/null
+fi
diff --git a/network/frr/frr.SlackBuild b/network/frr/frr.SlackBuild
new file mode 100644
index 0000000000..701fd9696a
--- /dev/null
+++ b/network/frr/frr.SlackBuild
@@ -0,0 +1,160 @@
+#!/bin/sh
+
+# Slackware build script for frr
+
+# Copyright 2018 Thibaut Notteboom, Paris, FRANCE
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=frr
+VERSION=${VERSION:-6.0}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+if [ "$(grep "^frr:x:357:357" /etc/passwd)" = "" -o \
+ "$(grep "^frr:x:357:" /etc/group)" = "" -o \
+ "$(grep "^frrvty:x:358:frr" /etc/group)" = "" ]; then
+cat << EOF
+The frr user/group and/or the frrvty group do not exist on this system.
+Before running this script, please add them with the following commands:
+
+groupadd -g 357 frr
+groupadd -g 358 frrvty
+useradd -c "FRR FRRouting suite" -d /var/run/frr -s /bin/false -u 357 -g frr -G frrvty frr
+
+EOF
+ exit 1
+fi
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$PRGNAM-$VERSION.tar.gz
+cd $PRGNAM-$PRGNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+./bootstrap.sh
+
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+./configure \
+ --prefix=/usr \
+ --sbindir=/usr/sbin \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --sysconfdir=/etc/frr \
+ --localstatedir=/var/run/frr \
+ --mandir=/usr/man \
+ --docdir=/usr/doc/$PRGNAM-$VERSION \
+ --infodir=/usr/info \
+ --enable-exampledir=/usr/doc/$PRGNAM-$VERSION/examples \
+ --enable-snmp=agentx \
+ --enable-multipath=256 \
+ --enable-user=frr \
+ --enable-group=frr \
+ --enable-vty-group=frrvty \
+ --enable-configfile-mask=0640 \
+ --enable-logfile-mask=0640 \
+ --enable-shell-access \
+ --enable-rpki \
+ --enable-fpm \
+ --enable-vtysh \
+ --enable-watchfrr \
+ --disable-systemd \
+ --disable-static \
+ --without-libpam \
+ --build=$ARCH-slackware-linux
+
+make
+make install-strip DESTDIR=$PKG
+
+install -d -m 750 -o frr -g frr $PKG/etc/frr $PKG/var/log/frr $PKG/var/run/frr
+
+install -D -m 640 -o frr -g frr redhat/daemons $PKG/etc/frr/daemons.new
+install -D -m 640 -o frr -g frrvty tools/etc/frr/vtysh.conf $PKG/etc/frr/vtysh.conf.new
+
+install -D -m 644 redhat/frr.init $PKG/etc/rc.d/rc.frr.new
+install -D -m 644 redhat/frr.logrotate $PKG/etc/logrotate.d/frr.new
+
+install -D -m 644 bgpd/BGP4-MIB.txt $PKG/usr/share/snmp/mibs/BGP4-MIB.txt
+install -D -m 644 eigrpd/EIGRP-MIB.txt $PKG/usr/share/snmp/mibs/EIGRP-MIB.txt
+install -D -m 644 ospf6d/OSPFv3-MIB.txt $PKG/usr/share/snmp/mibs/OSPFv3-MIB.txt
+install -D -m 644 ospfd/OSPF-MIB.txt $PKG/usr/share/snmp/mibs/OSPF-MIB.txt
+install -D -m 644 ospfd/OSPF-TRAP-MIB.txt $PKG/usr/share/snmp/mibs/OSPF-TRAP-MIB.txt
+install -D -m 644 ripd/RIPv2-MIB.txt $PKG/usr/share/snmp/mibs/RIPv2-MIB.txt
+
+# Fix paths
+sed -i 's|usr/lib/frr|usr/sbin|g' $PKG/etc/rc.d/rc.frr.new $PKG/etc/frr/daemons.new
+
+# Don't ship .la files:
+rm -f $PKG/{,usr/}lib${LIBDIRSUFFIX}/*.la
+rm -f $PKG/usr/lib${LIBDIRSUFFIX}/frr/modules/*.la
+
+find $PKG/usr/man -type f -exec gzip -9 {} \;
+for i in $( find $PKG/usr/man -type l ) ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+
+rm -f $PKG/usr/info/dir
+gzip -9 $PKG/usr/info/*.info*
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ AUTHORS COPYING* ChangeLog INSTALL NEWS README* \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/network/frr/frr.info b/network/frr/frr.info
new file mode 100644
index 0000000000..d653abc141
--- /dev/null
+++ b/network/frr/frr.info
@@ -0,0 +1,10 @@
+PRGNAM="frr"
+VERSION="6.0"
+HOMEPAGE="https://frrouting.org/"
+DOWNLOAD="https://github.com/FRRouting/frr/archive/frr-6.0/frr-frr-6.0.tar.gz"
+MD5SUM="f7584302a8837194021b82ae646d5e2d"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="perl-xml-libxml c-ares ipaddr-py Sphinx rtrlib"
+MAINTAINER="Thibaut Notteboom"
+EMAIL="thibaut.notteboom@gmail.com"
diff --git a/network/frr/slack-desc b/network/frr/slack-desc
new file mode 100644
index 0000000000..dead5f5221
--- /dev/null
+++ b/network/frr/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+frr: frr (The FRRouting Protocol Suite)
+frr:
+frr: FRRouting is free software that manages various IPv4 and IPv6 routing
+frr: protocols.
+frr:
+frr: Currently FRRouting supports BGP4, BGP4+, OSPFv2, OSPFv3, RIPv1,
+frr: RIPv2, RIPng, IS-IS, PIM-SM/MSDP and LDP as well as very early
+frr: support for EIGRP and NHRP.
+frr:
+frr: FRRouting is a fork of Quagga and conflicts with it.
+frr: